---
title: transition
slug: Web/CSS/transition
tags:
  - CSS
  - CSS Property
  - CSS Transitions
  - Reference
  - 'recipe:css-shorthand-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>transition</code></strong> <a href="/en/CSS" title="CSS">CSS </a>property is a <a href="/en-US/docs/Web/CSS/Shorthand_properties" title="/en-US/docs/CSS/Shorthand_properties">shorthand property</a> for {{ cssxref("transition-property") }}, {{ cssxref("transition-duration") }}, {{ cssxref("transition-timing-function") }}, and {{ cssxref("transition-delay") }}.</p>

<div>{{EmbedInteractiveExample("pages/css/transition.html")}}</div>

<p>Transitions enable you to define the transition between two states of an element. Different states may be defined using <a href="/en-US/docs/Web/CSS/Pseudo-classes" title="/en-US/docs/CSS/Pseudo-classes">pseudo-classes</a> like {{cssxref(":hover")}} or {{cssxref(":active")}} or dynamically set using JavaScript.</p>

<h2 id="Constituent_properties">Constituent properties</h2>

<p>This property is a shorthand for the following CSS properties:</p>

<ul>
	<li><a href="/en-US/docs/Web/CSS/transition-delay"><code>transition-delay</code></a></li>
	<li><a href="/en-US/docs/Web/CSS/transition-duration"><code>transition-duration</code></a></li>
	<li><a href="/en-US/docs/Web/CSS/transition-property"><code>transition-property</code></a></li>
	<li><a href="/en-US/docs/Web/CSS/transition-timing-function"><code>transition-timing-function</code></a></li>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:css no-line-numbers notranslate">/* Apply to 1 property */
/* property name | duration */
transition: margin-right 4s;

/* property name | duration | delay */
transition: margin-right 4s 1s;

/* property name | duration | easing function */
transition: margin-right 4s ease-in-out;

/* property name | duration | easing function | delay */
transition: margin-right 4s ease-in-out 1s;

/* Apply to 2 properties */
transition: margin-right 4s, color 1s;

/* Apply to all changed properties */
transition: all 0.5s ease-out;

/* Global values */
transition: inherit;
transition: initial;
transition: unset;
</pre>

<p>The <code>transition</code> property is specified as one or more single-property transitions, separated by commas.</p>

<p>Each single-property transition describes the transition that should be applied to a single property (or the special values <code>all</code> and <code>none</code>). It includes:</p>

<ul>
	<li>zero or one value representing the property to which the transition should apply. This may be any one of:
	<ul>
		<li>the keyword <code>none</code></li>
		<li>the keyword <code>all</code></li>
		<li>a {{cssxref("&lt;custom-ident&gt;")}} naming a CSS property.</li>
	</ul>
	</li>
	<li>zero or one {{cssxref("&lt;easing-function&gt;")}} value representing the easing function to use</li>
	<li>zero, one, or two {{cssxref("&lt;time&gt;")}} values. The first value that can be parsed as a time is assigned to the {{cssxref("transition-duration")}}, and the second value that can be parsed as a time is assigned to {{cssxref("transition-delay")}}.</li>
</ul>

<p>See <a href="/en-US/docs/Web/CSS/CSS_Transitions/Using_CSS_transitions#When_property_value_lists_are_of_different_lengths" title="en/CSS/CSS transitions#When property value lists are of different lengths">how things are handled</a> when lists of property values aren't the same length. In short, extra transition descriptions beyond the number of properties actually being animated are ignored.</p>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{CSSInfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Simple_example">Simple example</h3>

<p>This example performs a four-second font size transition with a one-second delay when the user hovers over the element.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;a class="target"&gt;Hover over me&lt;/a&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">.target {
  font-size: 14px;
  transition: font-size 4s 1s;
}

.target:hover {
  font-size: 36px;
}
</pre>

<p>{{EmbedLiveSample('Simple_example', 600, 100)}}</p>

<p>There are several more examples of CSS transitions included in the <a href="/en-US/docs/Web/CSS/CSS_Transitions/Using_CSS_transitions" title="en/CSS/CSS transitions">Using CSS transitions</a> article.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{ SpecName('CSS3 Transitions', '#transition-shorthand-property', 'transition') }}</td>
			<td>{{ Spec2('CSS3 Transitions') }}</td>
			<td>Initial definition</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.transition")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/CSS/Using_CSS_transitions" title="en/CSS/CSS transitions">Using CSS transitions</a></li>
	<li>{{ domxref("TransitionEvent") }}</li>
</ul>
